searchNodes=[{"doc":"HXL An Elixir implementation of HCL Features Decode from string or file Aims to be fully compliant with the HCL specification Function &amp; variables support during evaluation Example Usage hcl = &quot;&quot;&quot; resource &quot;upcloud_server&quot; &quot;server1&quot; { hostname = &quot;terraform.example.com&quot; zone = &quot;nl-ams1&quot; plan = &quot;1xCPU-1GB&quot; template { size = 25 storage = &quot;01000000-0000-4000-8000-000030200200&quot; } network_interface { type = &quot;public&quot; } login { user = &quot;root&quot; keys = [ &quot;ssh-rsa public key&quot;, ] create_password = true password_delivery = &quot;email&quot; } connection { host = &quot;127.0.0.2&quot; type = &quot;ssh&quot; user = &quot;root&quot; private_key = file(&quot;~/.ssh/rsa_private_key&quot;) } provisioner &quot;remote-exec&quot; { inline = [ &quot;echo &#39;Hello world!&#39;&quot; ] } } &quot;&quot;&quot; { :ok , config_file } = HXL . decode ( hcl , functions : %{ &quot;file&quot; =&gt; &amp; File . read / 1 } ) From file { :ok , config_file } = HXL . decode_file ( &quot;/path/to/file&quot; ) As ast hcl = &quot;&quot;&quot; service &quot;http&quot; { a = 1 b = 2 } &quot;&quot;&quot; { :ok % HXL.Body { } } = HXL . decode_as_ast ( hcl ) Installation Add hxl to your list of dependencies in mix.exs : def deps do [ { :hxl , &quot;~&gt; 0.1.0&quot; } ] end HCL Syntax Specification Lexical Elements [x] Comments [x] Identifiers [ ] Operators &amp; delimiters [x] Numeric literals Structural Elements [x] Body [x] Attributes [x] Blocks [x] One-line blocks [x] Expressions [x] Expr term [x] Literal Value [x] Collection Value [x] Template Expr [x] Variable Expr [x] Function Call [x] For Expr [x] ExprTerm Index [x] ExprTerm GetAttr [x] ExprTerm Splat [x] &quot;(&quot; Expression &quot;)&quot; [x] Operation [x] Conditional Represenations [ ] HCL Native syntax [ ] JSON","ref":"HXL.html","title":"HXL","type":"module"},{"doc":"Decode a binary to a HCL document. decode/2 parses and evaluates the AST before returning the HCL docuement. If the document is using functions in it's definition, these needs to be passed in the opts part of this functions. See bellow for an example Options The following options can be passed to configure evaluation of the document: :functions - A map of (&lt;function_name&gt; -&gt; &lt;function&gt;) to make available in document evaluation. :variables - A map of Top level variables that should be injected into the context when evaluating the document. :keys - controls how keys in the parsed AST are evaluated. Possible values are: :strings (default) - evaluates keys as strings :atoms - converts keys to atoms with String.to_atom/1 :atoms! - converts keys to atoms with String.to_existing_atom/1 (key -&gt; term) - converts keys using the provided function Examples Using functions: iex&gt; hcl = &quot;a = upper(trim(&quot; a &quot;))&quot; &quot;a = upper(trim(&quot; a &quot;))&quot; iex&gt; HXL . decode ( hcl , functions : %{ &quot;upper&quot; =&gt; &amp; String . capitalize / 1 , &quot;trim&quot; =&gt; &amp; String . trim / 1 } ) { :ok , %{ &quot;a&quot; =&gt; &quot;A&quot; } } Using variables: iex&gt; hcl = &quot;a = b&quot; &quot;a = b&quot; iex&gt; HXL . decode ( hcl , variables : %{ &quot;b&quot; =&gt; &quot;B&quot; } ) { :ok , %{ &quot;a&quot; =&gt; &quot;B&quot; } }","ref":"HXL.html#decode/2","title":"HXL.decode/2","type":"function"},{"doc":"Reads a HCL document from a binary. Returns the document or raises HXL.Error . See from_binary/1","ref":"HXL.html#decode!/2","title":"HXL.decode!/2","type":"function"},{"doc":"Decode a binary to a HXL document AST. Examples iex&gt; HXL . decode_as_ast ( &quot;a = 1&quot; ) { :ok , % HXL.Ast.Body { statements : [ % HXL.Ast.Attr { expr : % HXL.Ast.Literal { value : { :int , 1 } } , name : &quot;a&quot; } ] } }","ref":"HXL.html#decode_as_ast/1","title":"HXL.decode_as_ast/1","type":"function"},{"doc":"Reads a HCL document from file. Uses same options as decode/2 Examples iex&gt; HXL . decode_file ( &quot;/path/to/file.hcl&quot; ) { :ok , %{ &quot;a&quot; =&gt; &quot;b&quot; } }","ref":"HXL.html#decode_file/2","title":"HXL.decode_file/2","type":"function"},{"doc":"Reads a HCL document from file, returns the document directly or raises HXL.Error . See decode_file/1","ref":"HXL.html#decode_file!/2","title":"HXL.decode_file!/2","type":"function"},{"doc":"","ref":"HXL.html#t:opt/0","title":"HXL.opt/0","type":"type"},{"doc":"","ref":"HXL.html#t:opts/0","title":"HXL.opts/0","type":"type"},{"doc":"HCL Ast","ref":"HXL.Ast.html","title":"HXL.Ast","type":"module"},{"doc":"","ref":"HXL.Ast.html#t:collection_value/0","title":"HXL.Ast.collection_value/0","type":"type"},{"doc":"","ref":"HXL.Ast.html#t:expr_term/0","title":"HXL.Ast.expr_term/0","type":"type"},{"doc":"","ref":"HXL.Ast.html#t:t/0","title":"HXL.Ast.t/0","type":"type"},{"doc":"This module implements Config.Provider behaviour, so that HCL files can be used for configuration of releases. Usage config_providers : [ { HXL.Provider , [ { :system , &quot;RELEASE_ROOT&quot; , &quot;/path/to/config.hcl&quot; } ] } ] Using a keyword list with options config_providers : [ { HXL.Provider , path : &quot;/path/to/config.hcl&quot; , functions : %{ } , variables : %{ } } ]","ref":"HXL.Provider.html","title":"HXL.Provider","type":"module"},{"doc":"HXL.Error","ref":"HXL.Error.html","title":"HXL.Error","type":"exception"},{"doc":"Internal errors to printable messages","ref":"HXL.Error.html#format_reason/1","title":"HXL.Error.format_reason/1","type":"function"}]